/* $Id: main.m,v 1.3 2001/11/15 21:14:12 probert Exp $ */

#import <AppKit/AppKit.h>
#import "AppController.h"

#define APP_NAME @"GNUstep"

/*
 * Create the application's menu
 */

void createMenu();

/*
 * Initialise and go!
 */

int main(int argc, const char *argv[]) {
  NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
  AppController     *controller;
  
  [NSApplication sharedApplication];

  createMenu();

  controller = [[AppController alloc] init];
  [NSApp setDelegate:controller];
  
  RELEASE(pool);

  return NSApplicationMain (argc, argv);
}

void createMenu()
{
  NSMenu *menu;
  NSMenu *info;
  NSMenu *images;
  NSMenu *edit;
  NSMenu *services;
  NSMenu *windows;

  SEL action = @selector(method:);

  menu = [[NSMenu alloc] initWithTitle:APP_NAME];

  [menu addItemWithTitle:@"Info" action:@selector(showInfoPanel:) keyEquivalent:@""];
  [menu addItemWithTitle:@"Images" action:action keyEquivalent:@""];
  [menu addItemWithTitle:@"Edit" action:action keyEquivalent:@""];
  [menu addItemWithTitle:@"Inspector..." action:@selector(showInspector:) keyEquivalent:@"I"];
  [menu addItemWithTitle:@"Windows" action:action keyEquivalent:@""];
  [menu addItemWithTitle:@"Services" action:action keyEquivalent:@""];
  [menu addItemWithTitle:@"Hide" action:@selector(hide:) keyEquivalent:@"h"];
  [menu addItemWithTitle:@"Quit" action:@selector(terminate:) keyEquivalent:@"q"];

  info = AUTORELEASE([[NSMenu alloc] init]);
  [menu setSubmenu:info forItem:[menu itemWithTitle:@"Info"]];
  [info addItemWithTitle:@"Info Panel..." action:@selector(showInfoPanel:) keyEquivalent:@""];
  [info addItemWithTitle:@"Preferences" action:@selector(showPrefPanel:) keyEquivalent:@""];
  [info addItemWithTitle:@"Help" action:action keyEquivalent:@"?"];

  images = AUTORELEASE([[NSMenu alloc] init]);
  [images addItemWithTitle:@"Open File..." action:@selector(openImage:) keyEquivalent:@"o"];
  [images addItemWithTitle:@"Open Path..." action:@selector(openImages:) keyEquivalent:@"O"];
  [menu setSubmenu:images forItem:[menu itemWithTitle:@"Images"]];

  edit = AUTORELEASE([[NSMenu alloc] init]);
  [edit addItemWithTitle:@"Cut" action:action keyEquivalent:@"x"];
  [edit addItemWithTitle:@"Copy" action:action keyEquivalent:@"c"];
  [edit addItemWithTitle:@"Paste" action:action keyEquivalent:@"v"];
  [edit addItemWithTitle:@"Delete" action:action keyEquivalent:@""];
  [edit addItemWithTitle:@"Select All" action:action keyEquivalent:@"a"];
  [menu setSubmenu:edit forItem:[menu itemWithTitle:@"Edit"]];

  windows = AUTORELEASE([[NSMenu alloc] init]);
  [windows addItemWithTitle:@"Use as window's default size"
	   action:@selector(setDefaultSize:)
	   keyEquivalent:@""];
  [windows addItemWithTitle:@"Arrange"
	   action:@selector(arrangeInFront:)
	   keyEquivalent:@""];
  [windows addItemWithTitle:@"Miniaturize"
	   action:@selector(performMiniaturize:)
	   keyEquivalent:@"m"];
  [windows addItemWithTitle:@"Close"
	   action:@selector(performClose:)
	   keyEquivalent:@"w"];
  [menu setSubmenu:windows forItem:[menu itemWithTitle:@"Windows"]];

  services = AUTORELEASE([[NSMenu alloc] init]);
  [menu setSubmenu:services forItem:[menu itemWithTitle:@"Services"]];

  [NSApp setMainMenu:menu];
  [NSApp setServicesMenu: services];

}



